

Compute_probs <- function(data, thresholds,
                          ncores=1, quantile_dims=c('syear', 'ensemble'),
                          probs_dims=list('ensemble', 'bin'),
                          split_factor=1, na.rm=FALSE) {
                            
  quantiles <- Apply(data,
                     quantile_dims,
                     function(x, na.rm) {quantile(as.vector(x), 
				         thresholds,na.rm=na.rm)},
                     output_dims="bin",
                     ncores=ncores, 
                     na.rm=na.rm,
                     split_factor=split_factor)[[1]]
  
  if (na.rm == FALSE) {
    c2p <- function(x, t) {
    colMeans(convert2prob(as.vector(x), threshold = as.vector(t)))
    }
  } else {
    c2p <- function(x, t) {
      if (any(!is.na(x))){
        colMeans(convert2prob(as.vector(x), threshold = as.vector(t)))
      } else {
        c(NA, NA, NA)
      }
    }
  }

  probs <- Apply(data = list(x = data, t = quantiles),
                             target_dims = probs_dims,
                             c2p,
                             output_dims = "bin",
                             split_factor = split_factor,
                             ncores = ncores)[[1]]

  return(list(probs=probs, quantiles=quantiles))

}


