

recipe_file <- "modules/Loading/testing_recipes/recipe_4.yml"

source("modules/Loading/Loading.R")
source("modules/Calibration/Calibration.R")
source("modules/Skill/Skill.R")
source("modules/Saving/Save_data.R")

# Load datasets
data <- load_datasets(recipe_file)
## TODO: Instead of reading the recipe at each module, do it at the beginning?
recipe <- read_yaml(recipe_file)
# Calibrate datasets
calibrated_data <- calibrate_datasets(data, recipe)
# Compute skill metrics
skill_metrics <- compute_skill_metrics(calibrated_data$hcst, data$obs,
				       recipe, na.rm = T, ncores = 4)

# Export skill metrics onto outfile
outfile <- "/esarchive/scratch/vagudets/auto-s2s-tests/files/skill/test-metrics.nc"
save_metrics(skill_metrics, recipe, data$hcst, outfile, agg = "global")
