# Print a summary of the loaded data for the user, for each object.
# object: hindcast, forecast or reference data in s2dv_cube format.
## TODO: Incorporate into logger
## TODO: Adapt to daily/subseasonal cases
## TODO: Add check for missing files/NAs by dimension

data_summary <- function(object, frequency) {
  # Get name, leadtime months and date range
  object_name <- deparse(substitute(object))
  if (tolower(frequency) == "monthly_mean") {
    date_format <- '%b %Y'
  } else if (tolower(frequency) == "daily_mean") {
    date_format <- '%b %d %Y'
  }
  months <- unique(format(as.Date(object$Dates[[1]]), format = '%B'))
  months <- paste(as.character(months), collapse=", ")
  sdate_min <- format(min(as.Date(object$Dates[[1]])), format = date_format)
  sdate_max <- format(max(as.Date(object$Dates[[1]])), format = date_format)
  
  print("DATA SUMMARY:")
  print(paste0(object_name, " months: ", months))
  print(paste0(object_name, " range: ", sdate_min, " to ", sdate_max))
  print(paste0(object_name, " dimensions: "))
  print(dim(object$data))
  print(paste0("Statistical summary of the data in ", object_name, ":"))
  print(summary(object$data))
  print("---------------------------------------------")

}
  
