# recipe: the content of the recipe
# verifications: the output from check_recipe
# folder: the name of the output folder for this run
# logger: the log file obtain from prepare_outputs
divide_recipe <- function(recipe, verifications, folder, logger) {
  info(logger, "Spliting recipe in single verifications.")
  beta_recipe <- list(Description = append(recipe$Description, 
                                           "split version"),
                      Analysis = list(Horizon = recipe$Analysis$Horizon,
                                      Variables = NULL,
                                      Datasets = NULL,
                                      Time = NULL,
                                      Region = NULL,
                                      Regrid = recipe$Analysis$Regrid,
                                      Workflow = recipe$Analysis$Workflow,
                                      Output_format = 
                                              recipe$Analysis$Output_format),
                       Run = recipe$Run)
  # duplicate recipe by Variables considering dep and indep:
  all_recipes <- list(beta_recipe)
  i <- 1 # to get track of the recipe number
  for (indep in verifications$independent) {
    all_recipes[[i]]$Analysis$Variables <- indep
    i = i + 1
    all_recipes <- append(all_recipes, list(beta_recipe))
  }
  for (dep in verifications$dependent) {
    all_recipes[[i]]$Analysis$Variables <- dep
    i = i + 1
    all_recipes <- append(all_recipes, list(beta_recipe))
  }
  all_recipes <- all_recipes[-length(all_recipes)]
  # duplicate recipe by Datasets:
  # check Systems
  if (recipe$Analysis$Datasets$Multimodel) {
    for (reci in 1:length(all_recipes)) {
      all_recipes[[reci]]$Analysis$Datasets <- list(
                            System = recipe$Analysis$Datasets$System,
                            Multimodel = recipe$Analysis$Datasets$Multimodel,
                            Reference = NULL)
    }
  } else {
    for (sys in 1:length(recipe$Analysis$Datasets$System)) {
      for (reci in 1:length(all_recipes)) {
        all_recipes[[reci]]$Analysis$Datasets <- list(
                            System = recipe$Analysis$Datasets$System[[sys]],
                            Multimodel = recipe$Analysis$Datasets$Multimodel,
                            Reference = NULL)
      }
      if (sys == 1) {
        recipes <- all_recipes
      } else {
        recipes <- append(recipes, all_recipes)
      }
    }
    all_recipes <- recipes
    rm(list = 'recipes')
  }
  # check References
  for (ref in 1:length(recipe$Analysis$Datasets$Reference)) {
    for (reci in 1:length(all_recipes)) {
      all_recipes[[reci]]$Analysis$Datasets$Reference <- 
                           recipe$Analysis$Datasets$Reference[[ref]]
    }
    if (ref == 1) {
        recipes <- all_recipes
    } else {
        recipes <- append(recipes, all_recipes)
    }
  }
  all_recipes <- recipes
  # Duplicate recipe by Region
  recipes <- list()
  for (reg in 1:length(recipe$Analysis$Region)) {
    if (length(recipe$Analysis$Region[[reg]]) == 4) { ##TODO: THIS SHOULD BE ONLY CHECK IN THE RECIPE CHECKER?
      for (reci in 1:length(all_recipes)) {
        all_recipes[[reci]]$Analysis$Region <-
                              recipe$Analysis$Region[[reg]]
      }
      recipes <- append(recipes, all_recipes)
    }
  }
  all_recipes <- recipes
  rm(list = 'recipes')
  if (tolower(recipe$Analysis$Horizon) == 'seasonal') {
    for (sday in 1:length(recipe$Analysis$Time$sdate$fcst_sday)) {
      for (reci in 1:length(all_recipes)) {
      all_recipes[[reci]]$Analysis$Time <- list(sdate = list(
                      fcst_syear = recipe$Analysis$Time$sdate$fcst_syear,
                      fcst_sday = recipe$Analysis$Time$sdate$fcst_sday[[sday]]),
                      hcst_start = recipe$Analysis$Time$hcst_start,
                      hcst_end = recipe$Analysis$Time$hcst_end,
                      leadtimemin = recipe$Analysis$Time$leadtimemin,
                      leadtimemax = recipe$Analysis$Time$leadtimemax)
      }
      if (sday == 1) {
        recipes <- all_recipes
      } else {
        recipes <- append(recipes, all_recipes)
      } 
    }
    all_recipes <- recipes
    rm(list = 'recipes')
  } # Rest of horizons
  # Finally, save all recipes in saparated yaml files
  for (reci in 1:length(all_recipes)) {
    write_yaml(all_recipes[[reci]], 
               paste0(folder, "/logs/recipes/recipe_", reci, ".yml"))
  }
  text <- paste0("See folder ",folder,"/logs/recipes/ to see the individual recipes.")
  info(logger, text)
  return(all_recipes)
}
